#include <mysql.h> /* Headers for MySQL usage */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sql_lib.h"


/***********
 * GLOBALS *
 ***********/

static MYSQL demo_db;
static char *host = "mysql.ece.cmu.edu";
static char *username = "c18749t7";
static char *password = "g7&bor4ba";


/*************
 * FUNCTIONS *
 *************/

int borba_connect()
{
  /* Make connection with mysql_connect(MYSQL db, char *host, char *username,
     char *password */
  //if(!mysql_connect(&demo_db, "mysql.ece.cmu.edu", "c18749t7", "g7&bor4ba")){ 
  if(!mysql_connect(&demo_db, host, username, password)){ 
    printf(mysql_error(&demo_db));
    return -1;
  }

  /* Select the database we want to use */
  if(mysql_select_db(&demo_db, username)){
    printf(mysql_error(&demo_db));
    return -1;
  }

  return 0;
}

int borba_disconnect()
{
  mysql_close(&demo_db);
  return 0;
}

int borba_setup_tables()
{
  char query[255];

  /* Build query */
  sprintf(query, "CREATE TABLE borba_table (id int, value int)");
  printf("query: %s\n", query);

  /* Make query */
  if(mysql_real_query(&demo_db, query, strlen(query))){
    printf(mysql_error(&demo_db));
    return -1;
  }

  return 0;
}

int borba_update(int id, int value)
{
  char query[255];

  /* Build query */
  sprintf(query, "UPDATE borba_table SET value = %d WHERE id = %d", value, id);
  printf("query: %s\n", query);

  /* Make query */
  if(mysql_real_query(&demo_db, query, strlen(query))){
    printf(mysql_error(&demo_db));
    return -1;
  }

  return 0;
}

int borba_insert(int id, int value)
{
  char query[255];
  int insert_id;
  MYSQL_RES *res; /* To be used to fetch information into */
  MYSQL_ROW row;

  /* Build query */
  sprintf(query, "INSERT INTO borba_table(id, value) VALUES ('%d', '%d')", 
	  id, value);
  printf("query: %s\n", query);

  /* Make query */
  if(mysql_real_query(&demo_db, query, strlen(query))){
    printf(mysql_error(&demo_db));
    return -1;
  }

  /*
  // this function actually increments id automatically, but we need to set
  // our database flag AUTO_INCREMENT (not set now)
  insert_id=mysql_insert_id(&demo_db); // Find what id that data was given

  query = malloc(255);
  //sprintf(query, "SELECT demodata FROM demotable WHERE id='%d'", insert_id);
  sprintf(query, "SELECT id, value FROM borba_table WHERE id='%d'", id);
  if(mysql_real_query(&demo_db, query, strlen(query))){ // Make query
     printf(mysql_error(&demo_db));
     exit(1);
  }
  free(query);

  res=mysql_store_result(&demo_db); // Download result from server
  row=mysql_fetch_row(res); // Get a row from the results
  printf("You inserted '%s', '%s'.\n", row[0], row[1]);
  mysql_free_result(res); // Release memory used to store results.
  */

  return 0;
}
